Unit AR;

interface

uses Drivers, Objects, Views, Dialogs{, ColorTxt};

const
  cmSelect      = 144;
  cmOut         = 145;
  cmPrint       = 146;
  cmPrintTop    = 147;
  cmPrintBottom = 148;
  cmBeep        = 149;
  cmDoTest      = 150;
  cmInitTables  = 151;
  cmTech        = 152;
  cmCommonClr   = 153;

type
  DataRec4 = record
    RegimStr   : String[1];
    PassStr    : String[8];
    PrintStr   : String[50];
    DelayStr   : String[2];
    ResultStr  : String[80];
    end;
  PDataRec4 = ^DataRec4;

  { TCustomQuery }

  PCustomCommDial = ^TCustomCommDial;
  TCustomCommDial = object(TDialog)
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function Valid(Command : word): boolean; virtual;
    destructor Done; virtual;
  end;

const
  RCustomCommDial : TStreamRec = (
    ObjType: 12352;            {<--- Insert a unique number >= 100 here!!}
    VmtLink: Ofs(Typeof(TCustomCommDial)^);
    Load : @TCustomCommDial.Load;
    Store : @TCustomCommDial.Store);

implementation

{ TCustomCommDial }

constructor TCustomCommDial.Init;
var
  R: TRect;
  Control : PView;
begin
R.Assign(0, 0, 80, 25);
inherited Init(R, '騥 ');
Flags := Flags or wfGrow or wfZoom;

{ -- Buttons -- }

R.Assign(42, 2, 78, 4);
Control := New(PButton, Init(R, '室  ०', cmSelect, bfDefault));
Insert(Control);
R.Assign(42, 4, 78, 6);
Control := New(PButton, Init(R, '室  ⥪饣 ०', cmOut, bfNormal));
Insert(Control);
R.Assign(42, 6, 78, 8);
Control := New(PButton, Init(R, '㤮', cmBeep, bfNormal));
Insert(Control);
R.Assign(42, 8, 78, 10);
Control := New(PButton, Init(R, ' ப', cmPrint, bfNormal));
Insert(Control);
R.Assign(42, 10, 78, 12);
Control := New(PButton, Init(R, ' ', cmPrintTop, bfNormal));
Insert(Control);
R.Assign(42, 12, 78, 14);
Control := New(PButton, Init(R, '   祪', cmPrintBottom, bfNormal));
Insert(Control);
R.Assign(42, 14, 78, 16);
Control := New(PButton, Init(R, '⮢ ண', cmDoTest, bfNormal));
Insert(Control);
R.Assign(42, 16, 78, 18);
Control := New(PButton, Init(R, '樠 ⠡', cmInitTables, bfNormal));
Insert(Control);
R.Assign(42, 18, 78, 20);
Control := New(PButton, Init(R, '孮᪮ 㫥', cmTech, bfNormal));
Insert(Control);
R.Assign(42, 20, 78, 22);
Control := New(PButton, Init(R, '饥 襭', cmCommonClr, bfNormal));
Insert(Control);

{ StaticText & InputLines }

R.Assign(3, 2, 8, 4);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(10, 2, 13, 3);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(15, 2, 21, 4);
Control := New(PStaticText, Init(R, '஫'));
Insert(Control);
R.Assign(23, 2, 33, 3);
Control := New(PINputLine, Init(R, 8));
Insert(Control);

R.Assign(3, 8, 9, 10);
Control := New(PStaticText, Init(R, 'ப'));
Insert(Control);
R.Assign(11, 8, 38, 9);
Control := New(PInputLine, Init(R, 50));
Insert(Control);

R.Assign(3, 14, 23, 16);
Control := New(PStaticText, Init(R, 'ࢠ ( )'));
Insert(Control);
R.Assign(25, 14, 29, 15);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(3, 22, 18, 24);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(20, 22, 77, 23);
Control := New(PInputLine, Init(R, 80));
Insert(Control);

SelectNext(False);
end;

constructor TCustomCommDial.Load(var S: TStream);
begin
inherited Load(S);
end;

procedure TCustomCommDial.HandleEvent(var Event: TEvent);
begin
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

inherited HandleEvent(Event);
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

end;

procedure TCustomCommDial.Store(var S: TStream);
begin
inherited Store(S);
end;

function TCustomCommDial.Valid(Command : word): boolean;
var
  Result : boolean;
begin
Result := inherited Valid(Command);
Valid := Result;
end;

destructor TCustomCommDial.Done;
begin
inherited Done;
end;

end.
