Unit CR;

interface

uses Drivers, Objects, Views, Dialogs{, ColorTxt};

const
  cmSetDate    = 138;
  cmSetTime    = 139;
  cmSetPoint   = 140;
  cmSetLicense = 141;
  cmSetTable   = 142;
  cmReadTable  = 143;


type
  DataRec3 = record
    YearStr    : String[2];
    MonthStr   : String[2];
    DayStr     : String[2];
    HourStr    : String[2];
    MinStr     : String[2];
    SecStr     : String[2];
    PointPos   : String[1];
    TableNum   : String[2];
    RowNum     : String[4];
    FieldNum   : String[2];
    FieldVal   : String[50];
    FieldType  : word;
    FieldLen   : String[2];
    LicenseNum : String[2];
    LicenseVal : String[16];
    ResultStr  : String[80];
    end;
  PDataRec3 = ^DataRec3;

  { TCustomQuery }

  PCustomProgDial = ^TCustomProgDial;
  TCustomProgDial = object(TDialog)
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function Valid(Command : word): boolean; virtual;
    destructor Done; virtual;
  end;

const
  RCustomProgDial : TStreamRec = (
    ObjType: 12347;            {<--- Insert a unique number >= 100 here!!}
    VmtLink: Ofs(Typeof(TCustomProgDial)^);
    Load : @TCustomProgDial.Load;
    Store : @TCustomProgDial.Store);

implementation

{ TCustomProgDial }

constructor TCustomProgDial.Init;
var
  R: TRect;
  Control : PView;
begin
R.Assign(0, 0, 80, 25);
inherited Init(R, 'ணࠬ஢');
Flags := Flags or wfGrow or wfZoom;

{ -- Buttons -- }

R.Assign(42, 2, 78, 4);
Control := New(PButton, Init(R, '', cmSetDate, bfDefault));
Insert(Control);

R.Assign(42, 4, 78, 6);
Control := New(PButton, Init(R, '६', cmSetTime, bfNormal));
Insert(Control);

R.Assign(42, 6, 78, 8);
Control := New(PButton, Init(R, ' 筮 窨', cmSetPoint, bfNormal));
Insert(Control);

R.Assign(42, 8, 78, 10);
Control := New(PButton, Init(R, '⥭ ⠡', cmReadTable, bfNormal));
Insert(Control);

R.Assign(42, 10, 78, 12);
Control := New(PButton, Init(R, ' ⠡', cmSetTable, bfNormal));
Insert(Control);

R.Assign(42, 12, 78, 14);
Control := New(PButton, Init(R, ' 業', cmSetLicense, bfNormal));
Insert(Control);


{ -- StaticText & InputLines -- }

R.Assign(3, 2, 6, 4);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(8, 2, 12, 3);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(14, 2, 19, 4);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(22, 2, 26, 3);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(28, 2, 32, 4);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(37, 2, 41, 3);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(3, 4, 6, 6);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(8, 4, 12, 5);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(14, 4, 20, 6);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(22, 4, 26, 5);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(28, 4, 35, 6);
Control := New(PStaticText, Init(R, '㭤'));
Insert(Control);
R.Assign(37, 4, 41, 5);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(3, 6, 18, 8);
Control := New(PStaticText, Init(R, ' 窨'));
Insert(Control);
R.Assign(20, 6, 23, 7);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(3, 8, 10, 10);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(12, 8, 16, 9);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(18, 8, 21, 10);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(23, 8, 29, 9);
Control := New(PInputLine, Init(R, 4));
Insert(Control);
R.Assign(31, 8, 35, 10);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(37, 8, 41, 9);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(3, 10, 16, 12);
Control := New(PStaticText, Init(R, '祭 '));
Insert(Control);
R.Assign(18, 10, 41, 11);
Control := New(PInputLine, Init(R, 50));
Insert(Control);

R.Assign(3, 12, 16, 13);
Control := New(PStaticText, Init(R, ' '));
Insert(Control);
R.Assign(2, 13, 16, 15);
Control := New(PRadioButtons, Init(R,NewSItem('᫮',NewSItem('ப', Nil))));
Insert(Control);

R.Assign(18, 13, 31, 14);
Control := New(PStaticText, Init(R, ' '));
Insert(Control);
R.Assign(30, 13, 41, 14);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(3, 16, 20, 17);
Control := New(PStaticText, Init(R, '  '));
Insert(Control);
R.Assign(22, 16, 28, 17);
Control := New(PInputLine, Init(R, 2));
Insert(Control);
R.Assign(3, 18, 13, 20);
Control := New(PStaticText, Init(R, ' '));
Insert(Control);
R.Assign(15, 18, 41, 19);
Control := New(PInputLine, Init(R, 16));
Insert(Control);

R.Assign(3, 22, 18, 24);
Control := New(PStaticText, Init(R, ''));
Insert(Control);
R.Assign(20, 22, 77, 23);
Control := New(PInputLine, Init(R, 80));
Insert(Control);

SelectNext(False);
end;

constructor TCustomProgDial.Load(var S: TStream);
begin
inherited Load(S);
end;

procedure TCustomProgDial.HandleEvent(var Event: TEvent);
begin
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

inherited HandleEvent(Event);
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

end;

procedure TCustomProgDial.Store(var S: TStream);
begin
inherited Store(S);
end;

function TCustomProgDial.Valid(Command : word): boolean;
var
  Result : boolean;
begin
Result := inherited Valid(Command);
Valid := Result;
end;

destructor TCustomProgDial.Done;
begin
inherited Done;
end;

end.

