unit FR_REP;

interface

uses Drivers, Objects, Views, Dialogs{, ColorTxt};

const
  cmGetX                = 136; {   襭 }
  cmGetZ                = 137; {   襭 }
  cmEKLZActivate        = 139; { ⨢  }
  cmEKLZCloseArchive    = 140; { ⨥ 娢  }
  cmEKLZReport          = 141; {   }

type
  DataRec5 = record
    ReportType    : String[1];
    KPK           : String[10];
    BegSession    : string[4];
    EndSession    : string[4];
    BegDayStr     : String[2];
    BegMonthStr   : String[2];
    BegYearStr    : String[2];
    EndDayStr     : String[2];
    EndMonthStr   : String[2];
    EndYearStr    : String[2];
    ResultStr     : String[80];
    end;
  PDataRec5 = ^DataRec5;

  { TCustomQuery }

  PCustomReport = ^TCustomReport;
  TCustomReport = object(TDialog)
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function Valid(Command : word): boolean; virtual;
    destructor Done; virtual;
  end;

const
  RCustomReport : TStreamRec = (
    ObjType: 12353;            {<--- Insert a unique number >= 100 here!!}
    VmtLink: Ofs(Typeof(TCustomReport)^);
    Load : @TCustomReport.Load;
    Store : @TCustomReport.Store);

implementation

{ TCustomReport }

constructor TCustomReport.Init;
var
  R: TRect;
  Control : PView;
begin
R.Assign(0, 0, 80, 25);
inherited Init(R, ' /  / ');
Flags := Flags or wfGrow or wfZoom;

{ -- Buttons -- }

R.Assign(42, 2, 78, 4);
Control := New(PButton, Init(R, '  襭', cmGetX, bfNormal));
Insert(Control);

R.Assign(42, 4, 78, 6);
Control := New(PButton, Init(R, '  襭', cmGetZ, bfNormal));
Insert(Control);

R.Assign(42, 6, 78, 8);
Control := New(PButton, Init(R, '⨢ ', cmEKLZActivate, bfNormal));
Insert(Control);

R.Assign(42, 8, 78, 10);
Control := New(PButton, Init(R, '⨥ 娢 ', cmEKLZCloseArchive, bfNormal));
Insert(Control);

R.Assign(42, 10, 78, 12);
Control := New(PButton, Init(R, ' ', cmEKLZReport, bfNormal));
Insert(Control);

{ -- StaticText -- }

R.Assign(3, 2, 18, 3);
Control := New(PStaticText, Init(R, ' '));
Insert(Control);

R.Assign(3, 4, 18, 5);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

R.Assign(3, 6, 18, 7);
Control := New(PStaticText, Init(R, '. ᬥ'));
Insert(Control);

R.Assign(3, 8, 18, 9);
Control := New(PStaticText, Init(R, '. ᬥ'));
Insert(Control);

R.Assign(3, 10, 18, 11);
Control := New(PStaticText, Init(R, '. '));
Insert(Control);

R.Assign(3, 12, 18, 13);
Control := New(PStaticText, Init(R, '. '));
Insert(Control);

R.Assign(3, 22, 18, 23);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

{ -- InputLines -- }

R.Assign(20, 2, 37, 3);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(20, 4, 37, 5);
Control := New(PInputLine, Init(R, 10));
Insert(Control);

R.Assign(20, 6, 37, 7);
Control := New(PInputLine, Init(R, 4));
Insert(Control);

R.Assign(20, 8, 37, 9);
Control := New(PInputLine, Init(R, 4));
Insert(Control);

R.Assign(20, 10, 25, 11);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(26, 10, 31, 11);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(32, 10, 37, 11);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(20, 12, 25, 13);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(26, 12, 31, 13);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(32, 12, 37, 13);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(20, 22, 77, 23);
Control := New(PInputLine, Init(R, 80));
Insert(Control);


SelectNext(False);
end;

constructor TCustomReport.Load(var S: TStream);
begin
inherited Load(S);
end;

procedure TCustomReport.HandleEvent(var Event: TEvent);
begin
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

inherited HandleEvent(Event);
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

end;

procedure TCustomReport.Store(var S: TStream);
begin
inherited Store(S);
end;

function TCustomReport.Valid(Command : word): boolean;
var
  Result : boolean;
begin
Result := inherited Valid(Command);
Valid := Result;
end;

destructor TCustomReport.Done;
begin
inherited Done;
end;

end.

