unit FR_Q;

interface

uses Drivers, Objects, Views, Dialogs{, ColorTxt};

const
  cmGetSerialNumber     = 123; {  ᪮  }
  cmGetECRDate          = 124; {    ६ }
  cmGetCheckSumm        = 125; {  㬬 祪 }
  cmGetCashSumm         = 126; {  㬬  騪 }
  cmGetCheckID          = 127; {   祪 }
  cmGetSmenaID          = 128; {   ᬥ }
  cmGetDenom            = 129; {   窨 }
  cmGetROMVersion       = 130; {  ᨨ  }
  cmGetVersion          = 131; {  ᨨ ࠩ }
  cmGetCurrRegim        = 132; {   ﭨ }
  cmECRStatus           = 133; {  ﭨ }
  cmGetLastZSumm        = 134; {  ᫥ ᬥ ⮣ }
  cmReadLicense         = 135; {  ⨢஢ 業 }
  cmEKLZGetStatus       = 138; {  ﭨ  }
  cmGetRegister         = 139; {  ॣ }

type
  DataRec2 = record
    LicenseNum : String[1];
    RegisterNumber : String[2];
    RegisterPar1: String[1];
    RegisterPar2: String[1];
    ResultStr : String[80];
    end;
  PDataRec2 = ^DataRec2;

  { TCustomQuery }

  PCustomQuery = ^TCustomQuery;
  TCustomQuery = object(TDialog)
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function Valid(Command : word): boolean; virtual;
    destructor Done; virtual;
  end;

const
  RCustomQuery : TStreamRec = (
    ObjType: 12346;            {<--- Insert a unique number >= 100 here!!}
    VmtLink: Ofs(Typeof(TCustomQuery)^);
    Load : @TCustomQuery.Load;
    Store : @TCustomQuery.Store);

implementation

{ TCustomQuery }

constructor TCustomQuery.Init;
var
  R: TRect;
  Control : PView;
begin
R.Assign(0, 0, 80, 25);
inherited Init(R, '');
Flags := Flags or wfGrow or wfZoom;

{ -- Buttons -- }

R.Assign(2, 2, 38, 4);
Control := New(PButton, Init(R, 'ﭨ ', cmECRStatus, bfDefault));
Insert(Control);

R.Assign(2, 4, 38, 6);
Control := New(PButton, Init(R, ' ﭨ ', cmGetCurrRegim, bfNormal));
Insert(Control);

R.Assign(2, 6, 38, 8);
Control := New(PButton, Init(R, '᪮  ', cmGetSerialNumber, bfNormal));
Insert(Control);

R.Assign(2, 8, 38, 10);
Control := New(PButton, Init(R, '㬬 祪', cmGetCheckSumm, bfNormal));
Insert(Control);

R.Assign(2, 10, 38, 12);
Control := New(PButton, Init(R, '㬬 筮  騪', cmGetCashSumm, bfNormal));
Insert(Control);

R.Assign(2, 12, 38, 14);
Control := New(PButton, Init(R, '㬬 ᫥ ᬥ ⮣', cmGetLastZSumm, bfNormal));
Insert(Control);

R.Assign(2, 14, 38, 16);
Control := New(PButton, Init(R, 'ﭨ ', cmEKLZGetStatus, bfNormal));
Insert(Control);

{ ----------- }

R.Assign(42, 2, 78, 4);
Control := New(PButton, Init(R, ' 祪', cmGetCheckID, bfNormal));
Insert(Control);

R.Assign(42, 4, 78, 6);
Control := New(PButton, Init(R, ' ᬥ', cmGetSmenaID, bfNormal));
Insert(Control);

R.Assign(42, 6, 78, 8);
Control := New(PButton, Init(R, ' 筮 窨', cmGetDenom, bfNormal));
Insert(Control);

R.Assign(42, 8, 78, 10);
Control := New(PButton, Init(R, ' ', cmGetROMVersion, bfNormal));
Insert(Control);

R.Assign(42, 10, 78, 12);
Control := New(PButton, Init(R, ' ࠩ', cmGetVersion, bfNormal));
Insert(Control);

R.Assign(42, 12, 78, 14);
Control := New(PButton, Init(R, '  ६  ', cmGetECRDate, bfNormal));
Insert(Control);

R.Assign(42, 14, 78, 16);
Control := New(PButton, Init(R, '⨢஢ 業', cmReadLicense, bfNormal));
Insert(Control);

R.Assign(42, 16, 78, 18);
Control := New(PButton, Init(R, '', cmGetRegister, bfNormal));
Insert(Control);

{ -- StaticText -- }

R.Assign(3, 18, 18, 29);
Control := New(PStaticText, Init(R, ' 業'));
Insert(Control);

R.Assign(43, 18, 58, 19);
Control := New(PStaticText, Init(R, ' ॣ'));
Insert(Control);

R.Assign(43, 20, 58, 21);
Control := New(PStaticText, Init(R, 'ࠬ ॣ'));
Insert(Control);

R.Assign(3, 22, 18, 24);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

{ -- InputLines -- }

R.Assign(20, 18, 37, 19);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(60, 18, 77, 19);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(60, 20, 65, 21);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(72, 20, 77, 21);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(20, 22, 77, 23);
Control := New(PInputLine, Init(R, 80));
Insert(Control);



SelectNext(False);
end;

constructor TCustomQuery.Load(var S: TStream);
begin
inherited Load(S);
end;

procedure TCustomQuery.HandleEvent(var Event: TEvent);
begin
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

inherited HandleEvent(Event);
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

end;

procedure TCustomQuery.Store(var S: TStream);
begin
inherited Store(S);
end;

function TCustomQuery.Valid(Command : word): boolean;
var
  Result : boolean;
begin
Result := inherited Valid(Command);
Valid := Result;
end;

destructor TCustomQuery.Done;
begin
inherited Done;
end;

end.

